Index: palm/trunk/SOURCE/init_masks.f90
===================================================================
--- palm/trunk/SOURCE/init_masks.f90	(revision 3044)
+++ palm/trunk/SOURCE/init_masks.f90	(revision 3045)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Error messages revised
+! 
+! 2718 2018-01-02 08:49:38Z maronga
 ! Corrected "Former revisions" section
 ! 
@@ -192,9 +195,11 @@
     
 !
-!-- Parallel mask output not yet tested
+!-- Parallel mask output not yet supported. In check_parameters data format 
+!-- is restricted and is switched back to non-parallel output. Therefore the
+!-- following error can not occur at the moment.
     IF ( netcdf_data_format > 4 )  THEN
-       message_string = 'netCDF file formats '//                         &
-                        '3 (netCDF 4) and 4 (netCDF 4 Classic model)'//  &
-                        '&are currently not supported (not yet tested).'
+       message_string = 'netCDF file formats '//                               &
+                        '5 and 6 (with parallel I/O support)'//                &
+                        ' are currently not supported.'
        CALL message( 'init_masks', 'PA0328', 1, 2, 0, 6, 0 )
     ENDIF
@@ -258,6 +263,6 @@
           DO  WHILE ( do_mask_user(mid,j) /= ' '  .AND.  j <= 100 )
              IF ( i > 100 )  THEN
-                WRITE ( message_string, * ) 'number of output quantitities ', &
-                     'given by data_output_mask and data_output_mask_user ', &
+                WRITE ( message_string, * ) 'number of output quantitities ',  &
+                     'given by data_output_mask and data_output_mask_user ',   &
                      'exceeds the limit of 100'
                 CALL message( 'init_masks', 'PA0329', 1, 2, 0, 6, 0 )
@@ -290,5 +295,5 @@
              CASE ( 'e' )
                 IF ( constant_diffusion )  THEN
-                   WRITE ( message_string, * ) 'output of "', TRIM( var ), &
+                   WRITE ( message_string, * ) 'output of "', TRIM( var ),     &
                         '" requires constant_diffusion = .FALSE.'
                    CALL message( 'init_masks', 'PA0103', 1, 2, 0, 6, 0 )
@@ -298,5 +303,5 @@
              CASE ( 'lpt' )
                 IF ( .NOT. cloud_physics )  THEN
-                   WRITE ( message_string, * ) 'output of "', TRIM( var ), &
+                   WRITE ( message_string, * ) 'output of "', TRIM( var ),     &
                         '" requires cloud_physics = .TRUE.'
                    CALL message( 'init_masks', 'PA0108', 1, 2, 0, 6, 0 )
@@ -306,10 +311,10 @@
              CASE ( 'nc' )
                 IF ( .NOT. cloud_physics )  THEN
-                   WRITE ( message_string, * ) 'output of "', TRIM( var ), &
+                   WRITE ( message_string, * ) 'output of "', TRIM( var ),     &
                         '" requires cloud_physics = .TRUE.'
                    CALL message( 'init_masks', 'PA0108', 1, 2, 0, 6, 0 )
                  ELSEIF ( .NOT. microphysics_morrison ) THEN
-                   message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                         'res  = morrison'
+                   message_string = 'output of "' // TRIM( var ) // '" ' //    &
+                         'requires  = morrison'
                    CALL message( 'check_parameters', 'PA0359', 1, 2, 0, 6, 0 )
                 ENDIF
@@ -318,10 +323,10 @@
              CASE ( 'nr' )
                 IF ( .NOT. cloud_physics )  THEN
-                   WRITE ( message_string, * ) 'output of "', TRIM( var ), &
+                   WRITE ( message_string, * ) 'output of "', TRIM( var ),     &
                         '" requires cloud_physics = .TRUE.'
                    CALL message( 'init_masks', 'PA0108', 1, 2, 0, 6, 0 )
                  ELSEIF ( .NOT. microphysics_seifert ) THEN
-                   message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                         'res cloud_scheme = seifert_beheng'
+                   message_string = 'output of "' // TRIM( var ) // '"' //     &
+                         'requires cloud_scheme = seifert_beheng'
                    CALL message( 'check_parameters', 'PA0359', 1, 2, 0, 6, 0 )
                 ENDIF
@@ -330,6 +335,6 @@
              CASE ( 'pc', 'pr' )
                 IF ( .NOT. particle_advection )  THEN
-                   WRITE ( message_string, * ) 'output of "', TRIM( var ), &
-                        '" requires a "particles_par"-NAMELIST in the ', &
+                   WRITE ( message_string, * ) 'output of "', TRIM( var ),     &
+                        '" requires a "particles_par"-NAMELIST in the ',       &
                         'parameter file (PARIN)'
                    CALL message( 'init_masks', 'PA0104', 1, 2, 0, 6, 0 )
@@ -340,5 +345,5 @@
              CASE ( 'q', 'vpt' )
                 IF ( .NOT. humidity )  THEN
-                   WRITE ( message_string, * ) 'output of "', TRIM( var ), &
+                   WRITE ( message_string, * ) 'output of "', TRIM( var ),     &
                         '" requires humidity = .TRUE.'
                    CALL message( 'init_masks', 'PA0105', 1, 2, 0, 6, 0 )
@@ -349,6 +354,6 @@
              CASE ( 'qc' )
                 IF ( .NOT. cloud_physics )  THEN
-                   message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                            'res cloud_physics = .TRUE.'
+                   message_string = 'output of "' // TRIM( var ) // '"' //     &
+                            'requires cloud_physics = .TRUE.'
                    CALL message( 'check_parameters', 'PA0108', 1, 2, 0, 6, 0 )
                 ENDIF
@@ -357,8 +362,8 @@
              CASE ( 'ql' )
                 IF ( .NOT. ( cloud_physics  .OR.  cloud_droplets ) )  THEN
-                   WRITE ( message_string, * ) 'output of "', TRIM( var ), &
+                   WRITE ( message_string, * ) 'output of "', TRIM( var ),     &
                         '" requires cloud_physics = .TRUE. or cloud_droplets', &
                         ' = .TRUE.'
-                   CALL message( 'init_masks', 'PA0108', 1, 2, 0, 6, 0 )
+                   CALL message( 'init_masks', 'PA0106', 1, 2, 0, 6, 0 )
                 ENDIF
                 unit = 'kg/kg'
@@ -366,5 +371,5 @@
              CASE ( 'ql_c', 'ql_v', 'ql_vp' )
                 IF ( .NOT. cloud_droplets )  THEN
-                   WRITE ( message_string, * ) 'output of "', TRIM( var ), &
+                   WRITE ( message_string, * ) 'output of "', TRIM( var ),     &
                         '" requires cloud_droplets = .TRUE.'
                    CALL message( 'init_masks', 'PA0107', 1, 2, 0, 6, 0 )
@@ -376,5 +381,5 @@
              CASE ( 'qv' )
                 IF ( .NOT. cloud_physics )  THEN
-                   WRITE ( message_string, * ) 'output of "', TRIM( var ), &
+                   WRITE ( message_string, * ) 'output of "', TRIM( var ),     &
                         '" requires cloud_physics = .TRUE.'
                    CALL message( 'init_masks', 'PA0108', 1, 2, 0, 6, 0 )
@@ -384,10 +389,10 @@
              CASE ( 'qr' )
                 IF ( .NOT. cloud_physics )  THEN
-                   message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                            'res cloud_physics = .TRUE.'
+                   message_string = 'output of "' // TRIM( var ) // '" ' //    &
+                            'requires cloud_physics = .TRUE.'
                    CALL message( 'check_parameters', 'PA0108', 1, 2, 0, 6, 0 )
                 ELSEIF ( .NOT. microphysics_seifert ) THEN
-                   message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                            'res cloud_scheme = seifert_beheng'
+                   message_string = 'output of "' // TRIM( var ) // '" ' //    &
+                            'requires cloud_scheme = seifert_beheng'
                    CALL message( 'check_parameters', 'PA0359', 1, 2, 0, 6, 0 )
                 ENDIF
@@ -396,5 +401,5 @@
              CASE ( 'rho_ocean' )
                 IF ( .NOT. ocean )  THEN
-                   WRITE ( message_string, * ) 'output of "', TRIM( var ), &
+                   WRITE ( message_string, * ) 'output of "', TRIM( var ),     &
                         '" requires ocean = .TRUE.'
                    CALL message( 'init_masks', 'PA0109', 1, 2, 0, 6, 0 )
@@ -404,5 +409,5 @@
              CASE ( 's' )
                 IF ( .NOT. passive_scalar )  THEN
-                   WRITE ( message_string, * ) 'output of "', TRIM( var ), &
+                   WRITE ( message_string, * ) 'output of "', TRIM( var ),     &
                         '" requires passive_scalar = .TRUE.'
                    CALL message( 'init_masks', 'PA0110', 1, 2, 0, 6, 0 )
@@ -412,5 +417,5 @@
              CASE ( 'sa' )
                 IF ( .NOT. ocean )  THEN
-                   WRITE ( message_string, * ) 'output of "', TRIM( var ), &
+                   WRITE ( message_string, * ) 'output of "', TRIM( var ),     &
                         '" requires ocean = .TRUE.'
                    CALL message( 'init_masks', 'PA0109', 1, 2, 0, 6, 0 )
@@ -419,6 +424,6 @@
 
              CASE ( 'u*', 't*', 'lwp*', 'pra*', 'prr*', 'z0*', 'z0h*' )
-                WRITE ( message_string, * ) 'illegal value for data_',&
-                     'output: "', TRIM( var ), '" is only allowed', &
+                WRITE ( message_string, * ) 'illegal value for data_',         &
+                     'output: "', TRIM( var ), '" is only allowed',            &
                      'for horizontal cross section'
                 CALL message( 'init_masks', 'PA0111', 1, 2, 0, 6, 0 )
@@ -437,11 +442,11 @@
                 IF ( unit == 'illegal' )  THEN
                    IF ( do_mask_user(mid,1) /= ' ' )  THEN
-                      WRITE ( message_string, * ) 'illegal value for data_',&
-                           'output or data_output_user: "', &
+                      WRITE ( message_string, * ) 'illegal value for data_',   &
+                           'output_masks or data_output_masks_user: "',        &
                            TRIM( do_mask(mid,i) ), '"'
-                      CALL message( 'init_masks', 'PA0114', 1, 2, 0, 6, 0 )
+                      CALL message( 'init_masks', 'PA0018', 1, 2, 0, 6, 0 )
                    ELSE
-                      WRITE ( message_string, * ) 'illegal value for data_',&
-                           'output: "', TRIM( do_mask(mid,i) ), '"'
+                      WRITE ( message_string, * ) 'illegal value for data_',   &
+                           ' output_masks : "', TRIM( do_mask(mid,i) ), '"'
                       CALL message( 'init_masks', 'PA0330', 1, 2, 0, 6, 0 )
                    ENDIF
@@ -643,6 +648,6 @@
              ENDIF
              IF ( m > (nxyz+1) )  THEN
-                WRITE ( message_string, '(I3,A,I3,A,I1,3A,I3)' )  &
-                     m,' in mask ',mid,' along dimension ',dim,  &
+                WRITE ( message_string, '(I3,A,I3,A,I1,3A,I3)' )               &
+                     m,' in mask ',mid,' along dimension ',dim,                &
                      ' exceeds (',nxyz_string,'+1) = ',nxyz+1
                 CALL message( 'init_masks', 'PA0331', 1, 2, 0, 6, 0 )
@@ -681,16 +686,16 @@
                   > (nxyz+1) * dxyz / mask_scale(dim) )  THEN
                 WRITE ( message_string, '(2(A,I3,A,I1,A,F9.3),5A,I1,A,F9.3)' ) &
-                     'mask_loop(',mid,',',dim,',1)=',mask_loop(mid,dim,1), &
+                     'mask_loop(',mid,',',dim,',1)=',mask_loop(mid,dim,1),     &
                      ' and/or mask_loop(',mid,',',dim,',2)=', &
-                     mask_loop(mid,dim,2),'&exceed (', &
-                     nxyz_string,'+1)*',dxyz_string,'/mask_scale(',dim,')=', &
+                     mask_loop(mid,dim,2),' exceed (', &
+                     nxyz_string,'+1)*',dxyz_string,'/mask_scale(',dim,')=',   &
                      (nxyz+1)*dxyz/mask_scale(dim)
                 CALL message( 'init_masks', 'PA0332', 1, 2, 0, 6, 0 )
              ENDIF
-             loop_begin  = NINT( mask_loop(mid,dim,1) * mask_scale(dim) &
+             loop_begin  = NINT( mask_loop(mid,dim,1) * mask_scale(dim)        &
                   * ddxyz - 0.5_wp )
-             loop_end    = NINT( mask_loop(mid,dim,2) * mask_scale(dim) &
+             loop_end    = NINT( mask_loop(mid,dim,2) * mask_scale(dim)        &
                   * ddxyz - 0.5_wp )
-             loop_stride = NINT( mask_loop(mid,dim,3) * mask_scale(dim) &
+             loop_stride = NINT( mask_loop(mid,dim,3) * mask_scale(dim)        &
                   * ddxyz )
              IF ( loop_begin == -1 )  loop_begin = 0  ! avoid negative values
@@ -702,8 +707,8 @@
              IF ( MAXVAL( mask_loop(mid,dim,1:2) )  &
                   > zu(nz+1) / mask_scale(dim) )  THEN
-                WRITE ( message_string, '(2(A,I3,A,I1,A,F9.3),A,I1,A,F9.3)' ) &
-                     'mask_loop(',mid,',',dim,',1)=',mask_loop(mid,dim,1), &
+                WRITE ( message_string, '(2(A,I3,A,I1,A,F9.3),A,I1,A,F9.3)' )  &
+                     'mask_loop(',mid,',',dim,',1)=',mask_loop(mid,dim,1),     &
                      ' and/or mask_loop(',mid,',',dim,',2)=', &
-                     mask_loop(mid,dim,2),'&exceed zu(nz+1)/mask_scale(',dim, &
+                     mask_loop(mid,dim,2),' exceed zu(nz+1)/mask_scale(',dim,  &
                      ')=',zu(nz+1)/mask_scale(dim)
                 CALL message( 'init_masks', 'PA0333', 1, 2, 0, 6, 0 )
@@ -724,9 +729,9 @@
              IF ( mask_loop(mid,dim,2) * mask_scale(dim) > dz_stretch_level )  &
                   THEN
-                WRITE ( message_string, '(A,I3,A,I1,A,F9.3,A,F8.2,3A)' ) &
-                     'mask_loop(',mid,',',dim,',2)=', mask_loop(mid,dim,2),&
-                     ' exceeds dz_stretch_level=',dz_stretch_level, &
-                     '.&Vertical mask locations will not ', &
-                     'match the desired heights&within the stretching ', &
+                WRITE ( message_string, '(A,I3,A,I1,A,F9.3,A,F8.2,3A)' )       &
+                     'mask_loop(',mid,',',dim,',2)=', mask_loop(mid,dim,2),    &
+                     ' exceeds dz_stretch_level=',dz_stretch_level,            &
+                     '. Vertical mask locations will not ',                    &
+                     'match the desired heights within the stretching ',       &
                      'region.'
                 CALL message( 'init_masks', 'PA0334', 0, 1, 0, 6, 0 )
Index: palm/trunk/SOURCE/init_pegrid.f90
===================================================================
--- palm/trunk/SOURCE/init_pegrid.f90	(revision 3044)
+++ palm/trunk/SOURCE/init_pegrid.f90	(revision 3045)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Error messages revised
+! 
+! 2938 2018-03-27 15:52:42Z suehring
 ! - No checks for domain decomposition in case of turbulence generator 
 !  (is done in stg module)
@@ -341,6 +344,6 @@
 !--    must be equal to the number of PEs available to the job
        IF ( ( npex * npey ) /= numprocs )  THEN
-          WRITE( message_string, * ) 'number of PEs of the prescribed ',   &
-              'topology (', npex*npey,') does not match & the number of ', &
+          WRITE( message_string, * ) 'number of PEs of the prescribed ',       &
+              'topology (', npex*npey,') does not match the number of ',       &
               'PEs available to the job (', numprocs, ')'
           CALL message( 'init_pegrid', 'PA0221', 1, 2, 0, 6, 0 )
@@ -353,6 +356,6 @@
 !--    If the processor topology is prescribed by the user, the number of
 !--    PEs must be given in both directions
-       message_string = 'if the processor topology is prescribed by th' //  &
-                'e user& both values of "npex" and "npey" must be given' // &
+       message_string = 'if the processor topology is prescribed by th' //     &
+                'e user both values of "npex" and "npey" must be given' //     &
                 ' in the &NAMELIST-parameter file'
        CALL message( 'init_pegrid', 'PA0222', 1, 2, 0, 6, 0 )
@@ -450,21 +453,14 @@
 !
 !-- Calculate array bounds along x-direction for every PE.
-    ALLOCATE( nxlf(0:pdims(1)-1), nxrf(0:pdims(1)-1), nynf(0:pdims(2)-1), &
+    ALLOCATE( nxlf(0:pdims(1)-1), nxrf(0:pdims(1)-1), nynf(0:pdims(2)-1),      &
               nysf(0:pdims(2)-1) )
 
     IF ( MOD( nx+1 , pdims(1) ) /= 0 )  THEN
-       WRITE( message_string, * ) 'x-direction: gridpoint number (',nx+1,') ',&
-                               'is not an& integral divisor of the number ',  &
-                               'processors (', pdims(1),')'
+       WRITE( message_string, * ) 'x-direction: gridpoint number (',nx+1,') ', &
+                               'is not an integral divisor of the number ',    &
+                               'of processors (', pdims(1),')'
        CALL message( 'init_pegrid', 'PA0225', 1, 2, 0, 6, 0 )
     ELSE
        nnx  = ( nx + 1 ) / pdims(1)
-       IF ( nnx*pdims(1) - ( nx + 1) > nnx )  THEN
-          WRITE( message_string, * ) 'x-direction: nx does not match the',    & 
-                       'requirements given by the number of PEs &used',       &
-                       '& please use nx = ', nx - ( pdims(1) - ( nnx*pdims(1) &
-                                      - ( nx + 1 ) ) ), ' instead of nx =', nx
-          CALL message( 'init_pegrid', 'PA0226', 1, 2, 0, 6, 0 )
-       ENDIF
     ENDIF    
 
@@ -480,16 +476,9 @@
     IF ( MOD( ny+1 , pdims(2) ) /= 0 )  THEN
        WRITE( message_string, * ) 'y-direction: gridpoint number (',ny+1,') ', &
-                           'is not an& integral divisor of the number of',     &
+                           'is not an integral divisor of the number of',      &
                            'processors (', pdims(2),')'
        CALL message( 'init_pegrid', 'PA0227', 1, 2, 0, 6, 0 )
     ELSE
        nny  = ( ny + 1 ) / pdims(2)
-       IF ( nny*pdims(2) - ( ny + 1) > nny )  THEN
-          WRITE( message_string, * ) 'y-direction: ny does not match the',    &
-                       'requirements given by the number of PEs &used ',      &
-                       '& please use ny = ', ny - ( pdims(2) - ( nnx*pdims(2) &
-                                     - ( ny + 1 ) ) ), ' instead of ny =', ny
-          CALL message( 'init_pegrid', 'PA0228', 1, 2, 0, 6, 0 )
-       ENDIF
     ENDIF    
 
@@ -533,5 +522,5 @@
           IF ( MOD( nz , pdims(1) ) /= 0 )  THEN
              WRITE( message_string, * ) 'transposition z --> x:',              &
-                       '&nz=',nz,' is not an integral divisior of pdims(1)=',  &
+                       ' nz=',nz,' is not an integral divisior of pdims(1)=',  &
                                                                    pdims(1)
              CALL message( 'init_pegrid', 'PA0230', 1, 2, 0, 6, 0 )
@@ -555,5 +544,5 @@
        IF ( MOD( nx+1 , pdims(2) ) /= 0 )  THEN
           WRITE( message_string, * ) 'transposition x --> y:',                 &
-                            '&nx+1=',nx+1,' is not an integral divisor of ',   &
+                            ' nx+1=',nx+1,' is not an integral divisor of ',   &
                             'pdims(2)=',pdims(2)
           CALL message( 'init_pegrid', 'PA0231', 1, 2, 0, 6, 0 )
@@ -584,5 +573,5 @@
           IF ( MOD( ny+1 , pdims(1) ) /= 0 )  THEN
              WRITE( message_string, * ) 'transposition y --> z:',              &
-                               '& ny+1=',ny+1,' is not an integral divisor of',&
+                               ' ny+1=',ny+1,' is not an integral divisor of', &
                                ' pdims(1)=',pdims(1)
              CALL message( 'init_pegrid', 'PA0232', 1, 2, 0, 6, 0 )
@@ -595,5 +584,5 @@
           IF ( MOD( ny+1 , pdims(1) ) /= 0 )  THEN
              WRITE( message_string, * ) 'transposition x --> y:',              &
-                               '& ny+1=',ny+1,' is not an integral divisor of',&
+                               ' ny+1=',ny+1,' is not an integral divisor of', &
                                ' pdims(1)=',pdims(1)
              CALL message( 'init_pegrid', 'PA0233', 1, 2, 0, 6, 0 )
@@ -609,5 +598,5 @@
        IF ( MOD( nz, pdims(2) ) /= 0 )  THEN
           WRITE( message_string, * ) 'direct transposition z --> y (needed ',  &
-                    'for spectra):& nz=',nz,' is not an integral divisor of ', &
+                    'for spectra): nz=',nz,' is not an integral divisor of ',  &
                     'pdims(2)=',pdims(2)
           CALL message( 'init_pegrid', 'PA0234', 1, 2, 0, 6, 0 )
@@ -974,7 +963,7 @@
 !
 !--          Check pre-defined value and reset to default, if neccessary
-             IF ( mg_switch_to_pe0_level < mg_switch_to_pe0_level_l  .OR.  &
+             IF ( mg_switch_to_pe0_level < mg_switch_to_pe0_level_l  .OR.      &
                   mg_switch_to_pe0_level >= maximum_grid_level_l )  THEN
-                message_string = 'mg_switch_to_pe0_level ' // &
+                message_string = 'mg_switch_to_pe0_level ' //                  &
                                  'out of range and reset to 0'
                 CALL message( 'init_pegrid', 'PA0235', 0, 1, 0, 6, 0 )
@@ -1038,9 +1027,9 @@
              subdomain_size = ( nxr - nxl + 2 * nbgp + 1 ) * &
                               ( nyn - nys + 2 * nbgp + 1 ) * ( nzt - nzb + 2 )
-             gathered_size  = ( nxr_l - nxl_l + 3 ) * ( nyn_l - nys_l + 3 ) * &
+             gathered_size  = ( nxr_l - nxl_l + 3 ) * ( nyn_l - nys_l + 3 ) *  &
                               ( nzt_l - nzb + 2 )
 
 #else
-             message_string = 'multigrid gather/scatter impossible ' // &
+             message_string = 'multigrid gather/scatter impossible ' //        &
                           'in non parallel mode'
              CALL message( 'init_pegrid', 'PA0237', 1, 2, 0, 6, 0 )
@@ -1063,5 +1052,5 @@
 
 !
-!--    Temporary problem: Currently calculation of maxerror iin routine poismg crashes
+!--    Temporary problem: Currently calculation of maxerror in routine poismg crashes
 !--    if grid data are collected on PE0 already on the finest grid level.
 !--    To be solved later.
Index: palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 3044)
+++ palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 3045)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Error messages revised and added
+! 
+! 3026 2018-05-22 10:30:53Z schwenkel
 ! Changed the name specific humidity to mixing ratio, since we are computing
 ! mixing ratios.
@@ -431,5 +434,5 @@
     USE radiation_model_mod,                                                   &
         ONLY:  albedo, albedo_type, emissivity, force_radiation_call,          &
-               radiation_scheme, unscheduled_radiation_calls
+               radiation, radiation_scheme, unscheduled_radiation_calls
         
     USE statistics,                                                            &
@@ -1274,5 +1277,5 @@
          TRIM( surface_type ) /= 'water'       .AND.                           &
          TRIM( surface_type ) /= 'netcdf' )  THEN  
-       message_string = 'unknown surface type surface_type = "' //             &
+       message_string = 'unknown surface type: surface_type = "' //            &
                         TRIM( surface_type ) // '"'
        CALL message( 'lsm_check_parameters', 'PA0019', 1, 2, 0, 6, 0 )
@@ -1295,4 +1298,10 @@
        CALL message( 'lsm_check_parameters', 'PA0400', 1, 2, 0, 6, 0 )
     ENDIF
+    
+    IF (  .NOT.  radiation )  THEN
+       message_string = 'lsm requires '//                                      &
+                        'the radiation model to be switched on'
+       CALL message( 'lsm_check_parameters', 'PA0400', 1, 2, 0, 6, 0 )
+    ENDIF
 
     IF ( TRIM( surface_type ) == 'vegetation' )  THEN
@@ -1380,5 +1389,5 @@
                                      ' is not allowed in combination with ',   &
                                      'most_method = ', most_method
-          CALL message( 'lsm_check_parameters', 'PA0417', 1, 2, 0, 6, 0 )
+          CALL message( 'lsm_check_parameters', 'PA0414', 1, 2, 0, 6, 0 )
        ENDIF
 
@@ -1426,5 +1435,5 @@
              CALL message( 'lsm_check_parameters', 'PA0352', 1, 2, 0, 6, 0 )
           ENDIF
-
+          
           IF ( z0h_pavement == 9999999.9_wp )  THEN
              message_string = 'pavement_type = 0 (user_defined)'//             &
@@ -1630,7 +1639,7 @@
     DO  k = nzb_soil, nzt_soil-1
        dz_soil_center(k) = zs(k+1) - zs(k)
-       IF ( dz_soil_center(k) == 0.0_wp )  THEN
+       IF ( dz_soil_center(k) <= 0.0_wp )  THEN
           message_string = 'invalid soil layer configuration found ' //        &
-                           '(dz_soil_center(k) = 0.0)'
+                           '(dz_soil_center(k) <= 0.0)'
           CALL message( 'lsm_rrd_local', 'PA0140', 1, 2, 0, 6, 0 )
        ENDIF  
